
	LIST P=PIC16F627 , R=HEX
	include<p16f627.inc>
	

		ORG	0000H

		GOTO	Start

		; RAM 20h-33h vyuzivaji WXnaLCD rutiny
		; RAM 5Fh-5Fh vyuziva PIC-E.ASM
		; RAM 60h-63h vyuziva LCD.ASM
		; RAM 64h-71h vyuziva SERIAL.ASM (Inicializace)
		; RAM (Banka 1) 20h-21h vyuziva obsluha WX
		; RAM (Banka 1) zbytek do 6Fh vyuzito pro WX data
		
Version_Data:	
		ADDWF	PCL,F		; Relative addressing
		RETLW	a'W'
		RETLW	a'X'
		RETLW	a' '
		RETLW	a'D'
		RETLW	a'i'
		RETLW	a's'
		RETLW	a'p'
		RETLW	a'l'
		RETLW	a'a'
		RETLW	a'y'
		RETLW	a' '
		RETLW	a'v'
		RETLW	a'0'
		RETLW	a'.'
		RETLW	a'3'
		RETLW	a' '
		RETLW	00DH
		RETLW	00AH
		RETLW	000H

;
; tybytov komunikace LCD displae s radiem HD44780 a mikroadie PIC16F84.
;
; Dne 19.5.2001
;
; Pavel Prochzka
; hacesoft@mujmail.cz
; www.prochazka.zde.cz
; Z portu B je voln pouze bit 0. Ostatn vvody portu B pouv LCD display.
;Port A je cel voln.
;K ovldn Portu B bitu 0 pouvejte instrukce BCF PORTB,0 a BSF PORTB,0.
;K nastaven tohoto bitu jako vstupn/vstupn pouijte nsledujc sekvenci:
; 	BCF nebo BSF reg_trisb,0	
;	MOVf	reg_trisb,w
;	TRIS	PORTB
; Za podmnky e pob v peruen.
; Pokud nebudete pouvat peruen sta aby bity co pouv LCD display 
;byli nastavenu jako vstupn. Ale muste konfiguraci zapsat i do registru 
;'reg_trisb' jinak po proveden jakhokoliv pkazu s LCD displaem bude 
;bit 0 porty B nastaven jako vstupn (zkladn nastaven). Pokud vm 
;bude stait aby bit 0 portu B byl jen vstupn, tak nic nemuste
;konfigurovat.
; S portem A mete nakldat jakkoliv.
;
; Zapojeni LCD displae:		vvod PICu	vvod LCD
;				PORTB 1  	RS - vyber reg.
;				PORTB 2		RW - read/write
;				PORTB 3		E  - enable
;				PORTB 4		DB4
;				PORTB 5		DB5
;				PORTB 6		DB6
;				PORTB 7		DB7
; Vvody DB0 a DB3 z LCD displae pipojit na 0V.
 
 
LCD_TEMP	EQU	060H	; hodnota, ktera se ma poslat do LCD
reg_trisb	EQU	061H	; hodnota, ktera se vysle na TRISB
 
DELAY		EQU	062H	; Used in DELAYxxx routines
X_DELAY		EQU	063H	; Used in X_DELAYxxx routines
 
#define		e		PORTB,3
#define		rw		PORTB,2
#define		rs		PORTB,1
 
; inicializace LCD displae.
LCDINIT
	clrf	reg_trisb                   
    	MOVLW   0x01E
    	CALL    X_DELAY500      ; 30 * 0.5mS = 15mS
 
;***************** Nastaveni 8-bitove komunikace ***************************
 
	MOVLW   0x030           ; 8-bit-interface
    	call	SENDPRIKAZ
 
;*************** Nastaveni 4-bitove komunikace *****************************
 
	MOVLW   0x020           ; 4-bit-interface
	call	SENDPRIKAZ
 
;***************************************************************************
	MOVLW   0x028           ; 4-bit-interface, 2-lines
	CALL    LCDPUTCMD
	MOVLW   0x008           ; disp.off, curs.off, no-blink
	CALL    LCDPUTCMD
	MOVLW   0x001		;lcd smazat
	CALL    LCDPUTCMD
	MOVLW   0x00C           ; disp.on, curs.off
	CALL    LCDPUTCMD
	MOVLW   0x006		; Inkrementace, normalni mod.
	CALL    LCDPUTCMD
	RETURN
 
SENDPRIKAZ
	CALL    LCDBUSY			; Wait for LCD to be ready
	BCF     rw
	BCF     rs
	BSF     e
	call	Zapis_w			; Zapise reg. W na PortB.
	BCF     e
	return
 
; Ceka az Display dodela prikaz. Obsah reg. W se touto rutinou nemeni!
LCDBUSY
	movwf   LCD_TEMP		; Uloz reg. W do LCD_TEMP
	movf	reg_trisb,w
	andlw	b'00001111'
	iorlw	b'11110000'		; Byty 4 az 7 brany B jsou vstupni.
	movwf	reg_trisb
	;tris	PORTB
	BSF	STATUS,RP0		; Select page 1 (80H - FFH)
	MOVWF	TRISB			; Nastavit PORT B
	BCF	STATUS,RP0		; Select page 0 (00H - 7FH)
lcd_busy
	BCF     rs
	BSF     rw
	BSF     e
	movf    PORTB,w         	; Read busy flag + DDram address
	BCF     e
	BSF     e
	BCF     e
	andlw   b'10000000'		; Test na BF priznak.
	BTFSS   STATUS,Z
	goto    lcd_busy
	bcf     rw
	movf	reg_trisb,w
	andlw	b'00001111'        	; Byty 4 az 7 brany B jsou vystupni.       		
	movwf	reg_trisb
	;tris	PORTB
	BSF	STATUS,RP0		; Select page 1 (80H - FFH)
	MOVWF	TRISB			; Nastavit PORT B
	BCF	STATUS,RP0		; Select page 0 (00H - 7FH)
	movf    LCD_TEMP,w		; Obnov reg. W
	return
 
; Posle znak na Display.
LCDPUTCHAR
	CALL    LCDBUSY             ; Wait for LCD to be ready
	BCF     rw
	BSF     rs
	BSF     e
	call	Zapis_w			; Zapise reg. W na PortB.
	BCF     e
 
	BSF     e
	swapf	LCD_TEMP,f
	call	Zapis_w			; Zapise reg. W na PortB.
	BCF     e
	RETURN
 
; Posle prikaz na Display.
LCDPUTCMD
	call    SENDPRIKAZ
	BSF     e
	swapf	LCD_TEMP,f
	call	Zapis_w			; Zapise reg. W na PortB.
	BCF     e
    	return
 
; Prekopiruje obsah reg. LED_TEMP bity 4 az 7 na PORTB bity 4 az 7.
Zapis_w
	movlw	b'00001111'
	andwf	PORTB,f		
; Vynuluje bity 4 az 7 portub, vysledek ulozi do portb.
	movlw	b'11110000'
	andwf	LCD_TEMP,w	
; Vynuluje bity 0 az 3 lcd_temp, vysledek ulozi do w.
	iorwf	PORTB,f		
; OR mezi w a potrb, vysledek ulozit do portb.
	return
 
;***********************************  a 500uS delay @ 4MHz X-tal
DELAY500
	MOVLW       D'165'              ; +1        1 cycle
	MOVWF       DELAY               ; +2        1 cycle
DELAY500_LOOP
	DECFSZ      DELAY, F            ; step1     1 cycle
	GOTO        DELAY500_LOOP       ; step2     2 cycles
DELAY500_END
	RETURN                          ; +3        2 cycles
 
;***********************************  a delay of 'W' * 500mS
X_DELAY500
	MOVWF       X_DELAY             ; +1        1 cycle
X_DELAY500_LOOP
	CALL        DELAY500            ; step1     wait 500uSec
	DECFSZ      X_DELAY, F          ; step2     1 cycle
	GOTO        X_DELAY500_LOOP     ; step3     2 cycles
X_DELAY500_END
	RETURN                          ; +2        2 cycles
 

		; SERIAL.ASM

LCD_WX_ID_TF	EQU	064H		; registr
LCD_WX_ID_TC	EQU	065H		; registr
LCD_WX_ID_P	EQU	066H		; registr
LCD_WX_ID_H	EQU	067H		; registr

LCD_WX_STRT	EQU	070H		; registr
wx_data_endR	EQU	071H		; Registr s ukonc. znakem WX retezce

serialDelayCount EQU	068H		; Registr odecet zpozdeni serial delay
serialData	EQU	069H		; Registr pro byte k RX/TX
serialTemp	EQU	06AH		; Registr pro cosi?
serialCount	EQU	06BH		; Registr pro pocet bitu k odeslani
Dividend	EQU	06CH		; registr pro deleni trema
Quotient	EQU	06DH		; registr pro deleni trema
delay_time	EQU	06EH		; Casovaci konstanta RS232
delay_time3	EQU	06FH		; Casovaci konstanta RS232/3

SERIAL_IN	EQU	004H		; PORT A4 je RS232 input
SERIAL_OUT	EQU	003H		; PORT A3 je RS232 output
WX_LED		EQU	000H		; PORT B0 je LED pro WX DATA indikaci

serial_Delay:
		MOVWF	serialDelayCount	; ulozit W do delay pocitadla
		NOP				; Helps with high speed	

serial_Delay_Loop:				; odecitaci smycka
		DECFSZ	serialDelayCount,F	; odecist
		GOTO	serial_Delay_Loop	; jeste jsme neodcetli vse
		RETURN				; odecteno, Return


serial_Init:
		BSF	STATUS,RP0		; Select page 1 (80H - FFH)
		BSF	TRISA,SERIAL_IN		; Nastavit vstup
		BCF	TRISA,SERIAL_OUT	; Nastavit vystup
		MOVLW	b'10100111'		; Prescaler -> TMR0,
		MOVWF	OPTION_REG		; 1:256, rising edge
		BSF	TRISB,WX_LED		; Nastavit vstup
		BCF	STATUS,RP0		; Select page 0 (00H - 7FH)
		BCF	PORTA,SERIAL_OUT	; Vystup nastavit do LOW
		BSF	PORTB,WX_LED		; Vystup nastavit do HIGH
		MOVLW	EE_DELAY_TIME		; adresa RS-232 delay bytu v EEPROM
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	delay_time		; a ulozit ji sem
		CALL	Div3			; vydelit trema
		MOVWF	delay_time3		; a ulozit ji sem
		MOVLW	EE_WX_DATA_END		; adresa ukonc. znaku WX retezce
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	wx_data_endR		; a ulozit ji sem
		MOVLW	EE_WX_DATA_STRT		; adresa start znaku WX retezce
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	LCD_WX_STRT		; a ulozit ji sem
		MOVLW	EE_WX_ID_TF		; adresa Farhent. znaku WX retezce
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	LCD_WX_ID_TF		; a ulozit ji sem
		MOVLW	EE_WX_ID_TC		; adresa Celsi. znaku WX retezce
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	LCD_WX_ID_TC		; a ulozit ji sem
		MOVLW	EE_WX_ID_P		; adresa tlak. znaku WX retezce
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	LCD_WX_ID_P		; a ulozit ji sem
		MOVLW	EE_WX_ID_H		; adresa vlhk. znaku WX retezce
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	LCD_WX_ID_H		; a ulozit ji sem
		MOVLW	a'9'			; ascii '9' (39h)
		MOVWF	LCD_TempCMAXd		; ulozit sem
		MOVWF	LCD_TempCMAXj		; ulozit sem
		MOVWF	LCD_TempCMAXdes		; ulozit sem
		MOVWF	LCD_TempCMINd		; ulozit sem
		MOVWF	LCD_TempCMINj		; ulozit sem
		MOVWF	LCD_TempCMINdes		; ulozit sem
		MOVLW	a'-'			; ascii '-' (2Dh)
		MOVWF	LCD_TempCMAXz		; ulozit sem
		MOVLW	a' '			; ascii ' ' (20h)
		MOVWF	LCD_TempCMINz		; ulozit sem
		RETURN				; Return from subroutine

serial_Transmit:				; odesle byte po RS232
		MOVWF	serialData		; ulozit byte pro odeslani
		MOVLW	00AH			; 8 bitu 1 stop a 1 start bit
		MOVWF	serialCount		;
		BCF	STATUS,C		; Clear carry flag

serial_Transmit_Loop:
		BCF	PORTA,SERIAL_OUT	; zaciname s LOW na vystupu
		BTFSS	STATUS,C		; Skip if carry set
		BSF	PORTA,SERIAL_OUT	; kdyz posilame 0, poslat HIGH
		MOVF	delay_time, W		; rychlost RS232
		CALL	serial_Delay		; cekat dobu bitu
		BSF	STATUS,C		; Set carry flag
		RRF	serialData,F		; odrotovat bity odesilaneho 
		DECFSZ	serialCount,F		; bytu, odecist odeslany bit
		GOTO	serial_Transmit_Loop	; jeste neodeslany vsechny
		RETURN				; odeslano, Return

serialTXcr:
		MOVLW	00DH			; Odeslat CR
		GOTO	serial_SEND_byte		
		RETURN			

serialTXlf:
		MOVLW	00AH			; Odeslat LF
		GOTO	serial_SEND_byte
		RETURN


serialTXsp:	
		MOVLW	020H			; Odeslat mezeru
		GOTO	serial_SEND_byte
		RETURN

serial_SEND_byte:				; Odeslat znak ve W
		GOTO	serial_Transmit		; skok na odeslani

serial_Receive:					;
		BCF	serialData,00		; pripravime prijaty bit jako 0
		BTFSS	PORTA,SERIAL_IN		; pokud neprijimame data
		RETLW	000H			; tak navrat
		MOVLW	009H			; jinak cteme
		MOVWF	serialCount		; 9 bitu
		MOVF	delay_time3, W		; zkracena RS232
		CALL	serial_Delay		; cekat delku bitu

serial_Receive_Loop:				; 
		BCF	STATUS,C		; Clear carry flag
		BTFSS	PORTA,SERIAL_IN		; pokud prichazi 0
		BSF	STATUS,C		; Set carry flag
		RRF	serialData,F		; odrotovat serial data bits
		MOVF	delay_time, W		; rychlost RS232
		CALL	serial_Delay		; cekat delku bitu
		NOP				; keep timing w/ transmit
		DECFSZ	serialCount,F		; mame vsechny bity?
		GOTO	serial_Receive_Loop	; jeste ne, tak dalsi
		MOVF	serialData,W		; prijaty byte do W

serial_Receive_Stop:				;
		BTFSC	PORTA,SERIAL_IN		; cekat na 0 na serial in
		GOTO	serial_Receive_Stop	; je tam stale 1 (stop bit)
		BSF	serialData,00		; bit 0 nastavit na 1
		RETURN				; Return from subroutine


serial_Receive_BYTE:				; prijme byte z RS232 portu
		CALL	serial_Receive		; nacist byte
		BTFSS	serialData,00		; nacten? 
		GOTO	serial_Receive_BYTE	; ne, data zadna neprichazeji
		RETURN				; Byte nacten, Return
		
Div3:						;  Divide Contents of "w" by 3
		movwf  Dividend
		clrf   Quotient
Div3_Loop					;  Loop Until the Dividend == 0
		bcf    STATUS, C
		rrf    Dividend, f		;  Dividend /2 (ie "x/2" in Series)
		movf   Dividend, w		;   Is it Equal to Zero?
		btfsc  STATUS, Z
		goto  Div3_Done			;  If it is, then Stop
		addwf  Quotient, f		;  Add the Value to the Quotient
		rrf    Dividend, f		;  Dividend /2 (ie "x/4" in Series)
		movf   Dividend, w
		btfsc  STATUS, Z
		goto  Div3_Done
		subwf  Quotient, f		;  Quotient = Quotient-(Dividend / 4)
		goto   Div3_Loop
Div3_Done
		movf   Quotient, w		;  Return the Quotient
		return
		
		; EEPROM.ASM

EEPROM_Read_Byte:			; cte byte z adresy W EEPROM
		;ANDLW	03FH		; odmaskovat bity 6 a 7 pro 64Bytu RAM
		ANDLW	07FH		; odmaskovat bity 7 pro 128Bytu RAM
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		MOVWF	EEADR		; zapsat adresu, ze ktere budeme cist
		BSF	EECON1,RD	; bude se cist z EEPROM 
		MOVF	EEDATA,W	; a nacteme byte
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		RETURN			; Return from subroutine


EEPROM_Write_Byte:			; zapise byte na adresu W EEPROM
		;ANDLW	03FH		; odmaskovat bity 6 a 7 pro 64Bytu RAM
		ANDLW	07FH		; odmaskovat bit 7 pro 128Bytu RAM
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		MOVWF	EEADR		; zapsat adresu, kam budeme zapisovat
		BCF	INTCON,GIE	; Generalni zakaz preruseni
		BSF	EECON1,WREN	; Povolit EEPROM write
		MOVLW	055H		; REQUIRED WRITE SEQUENCE START
		MOVWF	EECON2		; Write 55h
		MOVLW	0AAH		; 
		MOVWF	EECON2		; Write AAh
		BSF	EECON1,WR	; Set WR bit, zapis spusten
		BCF	EECON1,WREN	; Zakazat EEPROM write
		BSF	INTCON,GIE	; Preruseni opet povolit

EEPROM_Write_Complete_Loop:		; ceka az se zapise do EEPROM
		BTFSC	EECON1,WR	; uz se byte zapsal?
		GOTO	EEPROM_Write_Complete_Loop	; jeste ne, cekat
		BCF	STATUS,RP0	; zapsano, Select page 0 (00H - 7FH)
		RETURN			; Return from subroutine

		; PIC-E.ASM

temp		EQU	05FH		; Registr docasny pro vse mozne
RES_MAX		EQU	005H		; SW na RA5 je reset MAXima teploty
RES_MIN		EQU	000H		; SW na RA0 je reset MINima teploty

Start:					; Start programu
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		MOVLW	07H		; odpojit 
		MOVWF	CMCON		; komparatory od A0-A3
		CALL	serial_Init	; Inicializace seriovych portu
		CALL	LCDINIT		; Inicializace LCD portu
		CALL	WX_RAM_Init	; Inicializace default WX dat
		CALL	Send_Version_LCD	; poslat verzi na LCD
		BCF	PORTB,WX_LED	; Zhasnout WX LEDku
		GOTO	Send_Version	; poslat verzi po RS232ce

Main_Loop:				; Hlavni smycka prg, cte z RS232
		BTFSS	PORTA, RES_MAX	; je stisknuto nulovani maxima?
		CALL	Prepis_TempCMAX_SUBR_LCD	; Prepsat maximum
		BTFSS	PORTA, RES_MIN	; je stisknuto nulovani minima?
		CALL	Prepis_TempCMIN_SUBR_LCD	; Prepsat minimum
		CALL	serial_Receive	; cist z RS232
		BTFSS	serialData,00	; prislo neco?
		GOTO	Main_Loop	; ne
		MOVWF	temp		; prislo, ulozit to sem
		XORLW	01BH		; je to ESC ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Serial_Receive_ESC	; prisel ESC, co prijde dal?
		MOVF	temp,W		; ESC to nebylo
		GOTO	Main_Loop	; bylo to neco jineho, ignorovat to

Serial_Receive_ESC:			; prislo ESC, zpracovavame asi prikaz
		CALL	serial_Receive_BYTE	; cist z RS232
		MOVWF	temp		; ulozit to sem
		XORLW	01BH		; prislo ESC ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Serial_Receive_ESC	; prislo ESC, cekame na prikaz
		MOVF	temp,W		; ESC to nebylo, zjistit prikaz
		XORLW	044H		; prislo D ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Write_Config_to_EEPROM	; 'D'=zapis konfigurace
		MOVF	temp,W		; obnovit prijaty znak
		XORLW	055H		; prislo U ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Send_Config_from_EEPROM	; 'U'=precteni konfigurace
		MOVF	temp,W		; obnovit prijaty znak
		XORLW	056H		; prislo V ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Send_Version	; 'V'=poslat verzi FirmWare
		MOVF	temp,W		; obnovit prijaty znak
		XORLW	052H		; prislo R ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	RAMsend		; 'R'=precteni obsahu RAM registru
		MOVF	temp,W		; obnovit prijaty znak

		XORLW	072H		; prislo r ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	WX_RAMsend	; 'r'=precteni obsahu WX RAM registru 
		MOVF	temp,W		; obnovit prijaty znak
		XORLW	077H		; prislo w ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Write_WX_to_RAM	; 'w'=zapsani do WX RAM registru
		MOVF	temp,W		; obnovit prijaty znak
		XORLW	075H		; prislo u ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Send_all_EEPROM	; 'u'=precteni cele EEPROM

		MOVF	temp,W		; obnovit prijaty znak
		XORLW	a'Q'		; prislo Q ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Start		; 'Q'= Restart celeho programu

		MOVF	temp,W		; obnovit prijaty znak
		XORLW	049H		; prislo I ?
		BTFSC	STATUS,Z	; Skip if not zero
		CALL	WX_RAM_Init	; 'I'= prepis EEPROM WX do RAM
		GOTO	Main_Loop	; bylo to neco jineho, ignorovat to

Write_Config_to_EEPROM:			; zapise data z RS232 do EEPROM
		CLRF	temp		; vynulovat ukazovatko

Write_Config_to_EEPROM_Loop:		; smycka zapisu do EEPROM
		CALL	serial_Receive_BYTE	; prijmout byte z RS232
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		MOVWF	EEDATA		; ulozit ho sem
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		MOVF	temp,W		; sem dat adresu bytu v EEPROM
		CALL	EEPROM_Write_Byte	; zapsat byte do EEPROM
		INCF	temp,F		; posun na dalsi byte
		BTFSS	temp,EEPROM_size_bit	; bylo jich uz 128?
		GOTO	Write_Config_to_EEPROM_Loop	; jeste ne, dalsi
		GOTO	Main_Loop	; hotovo a jedeme dokolecka

Send_Config_from_EEPROM:		; nacte data z EEPROM a posle na RS232
		MOVLW	EE_LEN		; delka dat v EEPROM
		CALL	serial_SEND_byte	; a poslat ji jako prvni
		CLRF	temp		; vynulovat ukazovatko

Send_Config_from_EEPROM_Loop:		; smycka cteni z EEPROM
		MOVF	temp,W		; vzit adresu bytu v EEPROM
		CALL	EEPROM_Read_Byte	; nacist ho
		CALL	serial_SEND_byte	; a poslat po RS232
		INCF	temp,F		; posun na dalsi byte
		BTFSS	temp,EEPROM_size_bit	; bylo jich uz 128?
		GOTO	Send_Config_from_EEPROM_Loop	; jeste ne, dalsi
		GOTO	Main_Loop	; vse odeslano, jedeme dokolecka

Send_Version:				; odesle po startu text verze 
		CLRF	temp		; po RS232, vynulovat temp_reg

Send_Version_serial:			; po RS232 odesle text verze FW
		MOVF	temp,W		; offset bytu verze
		CALL	Version_Data	; ziskat byte verze
		IORLW	000H		; je to binarni nula?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Version_just_send_serial	; je, cely text poslan
		CALL	serial_SEND_byte	; poslat byte
		INCF	temp,F		; posun na dalsi byte
		GOTO	Send_Version_serial	; a zpracovat ho

Version_just_send_serial:		;
		GOTO	Main_Loop	; a zpet do hlavni smycky

Send_Version_LCD:			; odesle po startu text verze 
		CLRF	temp		; na LCD, vynulovat temp_reg

Send_Version_LCD_loop:			; po RS232 odesle text verze FW
		MOVF	temp,W		; offset bytu verze
		CALL	Version_Data	; ziskat byte verze
		IORLW	000H		; je to binarni nula?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Version_just_send_LCD	; je, cely text poslan
 		CALL	LCDPUTCHAR	; Poslat znak na LCD
		INCF	temp,F		; posun na dalsi byte
		GOTO	Send_Version_LCD_loop	; a zpracovat ho

Version_just_send_LCD:			;
		RETURN			; navrat

		; Odesle obsah RAMky (dopsano)

RAMsend:				; posle obsah registru po RS232
		clrf	temp		; vynulovat ukazovatko

dalsiRAMB:				; odesilaci smycka
		movf	temp,W		; vzit adresu registru
		MOVWF	FSR		; dat ji sem a
		MOVF	INDF,W		; nacist obsah REG na adrese FSR
		CALL	serial_SEND_byte	; odeslat po RS-232
		INCF	temp,F		; dalsi REG
		BTFSS	STATUS,Z	; poslany vsechy REGistry?
		GOTO	dalsiRAMB	; jeste ne
		GOTO	Main_Loop	; poslano vse, zpet do hlavni smycky

		; WX Po RS232 obsluha

WX_temp		EQU	020H		; RP0=1, temp
WX_DATA_OFFSET	EQU	021H		; RP0=1, offset WX ramce v RAM
WX_DATA_END	EQU	00DH		; koncovy znak WX dat

Write_WX_to_RAM:			; zapsat WX do RAMky
		BSF	PORTB,WX_LED	; Rozsvitit WX LEDku
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		MOVLW	WX_DATA_OFFSET	; zacatek WX retezce
		MOVWF	WX_temp		; dat sem

Write_WX_to_RAM_Loop:			; smycka zapisu WX do RAM banky 1
		MOVF	WX_temp,W	; vzit adresu registru
		MOVWF	FSR		; dat ji sem a
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		CALL	serial_Receive_BYTE	; prijmout byte z RS232
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		BSF	FSR,7
		MOVWF	INDF		; zapsat byte na adresu FSR
		BCF	FSR,7
		INCF	WX_temp,F	; dalsi REG

		BTFSS	WX_temp,6	; nepretekli
		GOTO	WX_end_W_check	; jsme 
		BTFSS	WX_temp,5	; nepretekli
		GOTO	WX_end_W_check	; jsme 
		BTFSC	WX_temp,4	; v RAMce?
		GOTO	WX_end_W	; pretekli, konec 

WX_end_W_check:
		XORWF	wx_data_endR, W	; ukoncovaci znak WX retezce
		BTFSS	STATUS,Z	; prijaty vsechy WX registry?
		GOTO	Write_WX_to_RAM_Loop	; jeste ne, dalsi

WX_end_W:	
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)

		; Mame WX data, jdeme je zobrazit na LCD

		CALL	Pripr_WX_LCD	; Pripravit data pro LCD
		CALL	Zobr_WX_na_LCD	; A poslat data na LCD
		BCF	PORTB,WX_LED	; Zhasnout WX LEDku
		GOTO	Main_Loop	; hotovo a jedeme dokolecka

Pripr_WX_LCD				; Pripravi data pro LCD

LCD_temp0	EQU	020H		; registr pomocny

LCD_TempCz	EQU	021H		; registr
LCD_TempCd	EQU	022H		; registr
LCD_TempCj	EQU	023H		; registr
LCD_TempCdes	EQU	024H		; registr
LCD_TempCMAXz	EQU	025H		; registr
LCD_TempCMAXd	EQU	026H		; registr
LCD_TempCMAXj	EQU	027H		; registr
LCD_TempCMAXdes	EQU	028H		; registr
LCD_TempCMINz	EQU	029H		; registr
LCD_TempCMINd	EQU	02AH		; registr
LCD_TempCMINj	EQU	02BH		; registr
LCD_TempCMINdes	EQU	02CH		; registr

LCD_HumiD	EQU	02DH		; registr
LCD_HumiJ	EQU	02EH		; registr

LCD_PresT	EQU	02FH		; registr
LCD_PresS	EQU	030H		; registr
LCD_PresD	EQU	031H		; registr
LCD_PresJ	EQU	032H		; registr
LCD_PresDes	EQU	033H		; registr
		; 000/000g000t000b00000h00<CR>-000C
		; LCD_WX_STRT
		; LCD_WX_ID_TF
		; LCD_WX_ID_TC
		; LCD_WX_ID_P
		; LCD_WX_ID_H
		; wx_data_endR

		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		MOVLW	WX_DATA_OFFSET	; zacatek WX retezce
		MOVWF	WX_temp		; dat sem

WX_dalsiRAMB_LCD:				; odesilaci smycka
		MOVF	WX_temp,W	; vzit adresu registru
		MOVWF	FSR		; dat ji sem a
		BSF	FSR,7
		MOVF	INDF,W		; nacist obsah REG na adrese FSR
		BCF	FSR,7
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		MOVWF	LCD_temp0	; Ulozit znak sem

		MOVF	LCD_temp0,W	; obnovit prijaty znak
		XORWF	LCD_WX_ID_TC, W	; prislo ID Teploty C?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	LCD_TempC_prep	; pripravit teplotu
		
		MOVF	LCD_temp0,W	; obnovit prijaty znak
		XORWF	LCD_WX_ID_P, W	; prislo ID Tlaku?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	LCD_Pres_prep	; pripravit teplotu
		
		MOVF	LCD_temp0,W	; obnovit prijaty znak
		XORWF	LCD_WX_ID_H, W	; prislo ID Vlhkosti?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	LCD_Humi_prep	; pripravit teplotu
		
WX_dalsiRAMB_LCD_RET:			; sem skok z "podprogramu"
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		INCF	WX_temp,F	; dalsi REG

		BTFSS	WX_temp,6	; nepretekli
		GOTO	WX_end_LCD_check	; jsme 
		BTFSS	WX_temp,5	; nepretekli
		GOTO	WX_end_LCD_check	; jsme 
		BTFSC	WX_temp,4	; v RAMce?
		GOTO	WX_end_LCD	; pretekli, konec 

WX_end_LCD_check:
		BSF	FSR,7
		MOVF	INDF,W		; nacist obsah REG na adrese FSR
		BCF	FSR,7
		XORWF	wx_data_endR, W	; ukoncovaci znak WX retezce
		BTFSS	STATUS,Z	; prohledany vsechy WX registry?
		GOTO	WX_dalsiRAMB_LCD	; jeste ne
WX_end_LCD:
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)

		RETURN			; navrat

LCD_TempC_prep					;
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_TempCz		; Ulozit znak sem
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_TempCd		; Ulozit znak sem
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_TempCj		; Ulozit znak sem
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_TempCdes		; Ulozit znak sem

Test_TempCMAX					; test mame-li maximum
		MOVF	LCD_TempCz, W		; vzit znamenko (20H/2DH)
		SUBWF	LCD_TempCMAXz, W	; odecist aktualni od MAX
		BTFSS	STATUS, C		;
		GOTO	Test_Temp_CMIN		; MAX je +, AKT je -
		BTFSS	STATUS, Z		; kdyz AKT = MAX ... Z=1
		GOTO	Prepis_TempCMAX		; AKT je +, MAX je -

		BTFSC	LCD_TempCz, 0		; je znamenko kladne? (20h)
		GOTO	Test_TempCMAX_zap	; ne, je zaporne (2Dh)

		MOVF	LCD_TempCMAXd, W	; vzit MAX desitky 
		SUBWF	LCD_TempCd, W		; odecist MAX od aktualni
		BTFSS	STATUS, C		; kdyz AKT < MAX ... C=0
		GOTO	Test_Temp_CMIN		; AKT je mensi nez MAX
		BTFSS	STATUS, Z		; kdyz AKT = MAX ... Z=1
		GOTO	Prepis_TempCMAX		; AKT je vetsi nez MAX
		MOVF	LCD_TempCMAXj, W	; vzit MAX jednotky 
		SUBWF	LCD_TempCj, W		; odecist MAX od aktualni
		BTFSS	STATUS, C		; kdyz AKT < MAX ... C=0
		GOTO	Test_Temp_CMIN		; AKT je mensi nez MAX
		BTFSS	STATUS, Z		; kdyz AKT = MAX ... Z=1
		GOTO	Prepis_TempCMAX		; AKT je vetsi nez MAX
		MOVF	LCD_TempCMAXdes, W	; vzit MAX desetiny 
		SUBWF	LCD_TempCdes, W		; odecist MAX od aktualni
		BTFSS	STATUS, C		; kdyz AKT < MAX ... C=0
		GOTO	Test_Temp_CMIN		; AKT je mensi nez MAX
		BTFSS	STATUS, Z		; kdyz AKT = MAX ... Z=1
		GOTO	Prepis_TempCMAX		; AKT je vetsi nez MAX
		GOTO	Test_Temp_CMIN		; AKT je cele shodne s MAX
		
Test_TempCMAX_zap				; teplota pod nulou
		MOVF	LCD_TempCd, W		; vzit AKT desitky
		SUBWF	LCD_TempCMAXd, W	; odecist aktualni od MAX
		BTFSS	STATUS, C		; 
		GOTO	Test_Temp_CMIN		; AKT je zapornejsi nez MAX
		BTFSS	STATUS, Z		; kdyz AKT = MAX ... Z=1
		GOTO	Prepis_TempCMAX		; AKT je kladnejsi nez MAX
		MOVF	LCD_TempCj, W		; vzit AKT jednotky
		SUBWF	LCD_TempCMAXj, W	; odecist aktualni od MAX
		BTFSS	STATUS, C		;
		GOTO	Test_Temp_CMIN		; AKT je zapornejsi nez MAX
		BTFSS	STATUS, Z		; kdyz AKT = MAX ... Z=1
		GOTO	Prepis_TempCMAX		; AKT je kladnejsi nez MAX
		MOVF	LCD_TempCdes, W		; vzit AKT desetiny
		SUBWF	LCD_TempCMAXdes, W	; odecist aktualni od MAX
		BTFSS	STATUS, C		;
		GOTO	Test_Temp_CMIN		; AKT je zapornejsi nez MAX
		BTFSS	STATUS, Z		; kdyz AKT = MAX ... Z=1
		GOTO	Prepis_TempCMAX		; AKT je kladnejsi nez MAX
		GOTO	Test_Temp_CMIN		; AKT je cele shodne s MAX
		
Prepis_TempCMAX					; mame nove maximum
		CALL	Prepis_TempCMAX_SUBR	; vlastni prepis

Test_Temp_CMIN					; test mame-li minimum
		MOVF	LCD_TempCMINz, W	; vzit MIN znamenko (20H/2DH)
		SUBWF	LCD_TempCz, W		; odecist MIN od aktualniho
		BTFSS	STATUS, C		;
		GOTO	LCD_TempC_prep_END	; MIN je -, AKT je +
		BTFSS	STATUS, Z		; kdyz AKT = MAX ... Z=1
		GOTO	Prepis_TempCMIN		; MIN je +, AKT je -

		BTFSC	LCD_TempCz, 0		; je znamenko kladne? (20h)
		GOTO	Test_TempCMIN_zap	; ne, je zaporne (2Dh)

		MOVF	LCD_TempCd, W		; vzit AKT desitky
		SUBWF	LCD_TempCMINd, W	; odecist aktualni od MIN
		BTFSS	STATUS, C		; kdyz AKT > MIN ... C=0
		GOTO	LCD_TempC_prep_END	; AKT je vetsi nez MIN
		BTFSS	STATUS, Z		; kdyz AKT = MIN ... Z=1
		GOTO	Prepis_TempCMIN		; AKT je mensi nez MIN
		MOVF	LCD_TempCj, W		; vzit AKT jednotky
		SUBWF	LCD_TempCMINj, W	; odecist aktualni od MIN
		BTFSS	STATUS, C		; kdyz AKT > MIN ... C=0
		GOTO	LCD_TempC_prep_END	; AKT je vetsi nez MIN
		BTFSS	STATUS, Z		; kdyz AKT = MIN ... Z=1
		GOTO	Prepis_TempCMIN		; AKT je mensi nez MIN
		MOVF	LCD_TempCdes, W		; vzit AKT desetiny
		SUBWF	LCD_TempCMINdes, W	; odecist aktualni od MIN
		BTFSS	STATUS, C		; kdyz AKT > MIN ... C=0
		GOTO	LCD_TempC_prep_END	; AKT je vetsi nez MIN
		BTFSS	STATUS, Z		; kdyz AKT = MIN ... Z=1
		GOTO	Prepis_TempCMIN		; AKT je mensi nez MIN
		GOTO	LCD_TempC_prep_END	; AKT cele shodne s MIN
		
Test_TempCMIN_zap				; teplota pod nulou
		MOVF	LCD_TempCMINd, W	; vzit MIN desitky 
		SUBWF	LCD_TempCd, W		; odecist MIN od aktualni
		BTFSS	STATUS, C		; 
		GOTO	LCD_TempC_prep_END	; AKT je kladnejsi nez MIN
		BTFSS	STATUS, Z		; kdyz AKT = MIN ... Z=1
		GOTO	Prepis_TempCMIN		; AKT je zapornejsi nez MIN
		MOVF	LCD_TempCMINj, W	; vzit MIN jednotky 
		SUBWF	LCD_TempCj, W		; odecist MIN od aktualni
		BTFSS	STATUS, C		;
		GOTO	LCD_TempC_prep_END	; AKT je kladnejsi nez MIN
		BTFSS	STATUS, Z		; kdyz AKT = MIN ... Z=1
		GOTO	Prepis_TempCMIN		; AKT je zapornejsi nez MIN
		MOVF	LCD_TempCMINdes, W	; vzit MIN desetiny 
		SUBWF	LCD_TempCdes, W		; odecist MIN od aktualni
		BTFSS	STATUS, C		;
		GOTO	LCD_TempC_prep_END	; AKT je kladnejsi nez MIN
		BTFSS	STATUS, Z		; kdyz AKT = MIN ... Z=1
		GOTO	Prepis_TempCMIN		; AKT je zapornejsi nez MIN
		GOTO	LCD_TempC_prep_END	; AKT je cele shodne s MIN
		
Prepis_TempCMIN					; mame nove minimum
		CALL	Prepis_TempCMIN_SUBR	; vlastni prepis

LCD_TempC_prep_END				;
		GOTO	WX_dalsiRAMB_LCD_RET	;

LCD_Pres_prep					;
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_PresT		; Ulozit znak sem
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_PresS		; Ulozit znak sem
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_PresD		; Ulozit znak sem
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_PresJ		; Ulozit znak sem
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_PresDes		; Ulozit znak sem
		GOTO	WX_dalsiRAMB_LCD_RET

LCD_Humi_prep					;
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_HumiD		; Ulozit znak sem
		CALL	LCD_prep_WXzn		; ziskat znak z retezce
		MOVWF	LCD_HumiJ		; Ulozit znak sem
		GOTO	WX_dalsiRAMB_LCD_RET

LCD_prep_WXzn				;
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		INCF	WX_temp,F	; dalsi REG
		MOVF	WX_temp,W	; vzit adresu registru
		MOVWF	FSR		; dat ji sem a
		BSF	FSR,7
		MOVF	INDF,W		; nacist obsah REG na adrese FSR
		BCF	FSR,7
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		RETURN			;
		

Prepis_TempCMAX_SUBR			; mame nove maximum
		MOVF	LCD_TempCz, W	; vzit znamenko (20H/2DH)
		MOVWF	LCD_TempCMAXz	; ulozit sem
		MOVF	LCD_TempCd, W	; vzit desitky
		MOVWF	LCD_TempCMAXd	; ulozit sem
		MOVF	LCD_TempCj, W	; vzit jednotky
		MOVWF	LCD_TempCMAXj	; ulozit sem
		MOVF	LCD_TempCdes, W	; vzit desetiny
		MOVWF	LCD_TempCMAXdes	; ulozit sem
		RETURN			;

Prepis_TempCMIN_SUBR			; mame nove minimum
		MOVF	LCD_TempCz, W	; vzit znamenko (20H/2DH)
		MOVWF	LCD_TempCMINz	; ulozit sem
		MOVF	LCD_TempCd, W	; vzit desitky
		MOVWF	LCD_TempCMINd	; ulozit sem
		MOVF	LCD_TempCj, W	; vzit jednotky
		MOVWF	LCD_TempCMINj	; ulozit sem
		MOVF	LCD_TempCdes, W	; vzit desetiny
		MOVWF	LCD_TempCMINdes	; ulozit sem
		RETURN			;

Prepis_TempCMAX_SUBR_LCD		; prepsani maxima
		CALL	Prepis_TempCMAX_SUBR	; 
		GOTO	Zobr_WX_na_LCD	;

Prepis_TempCMIN_SUBR_LCD		; prepsani minima
		CALL	Prepis_TempCMIN_SUBR	; 
		GOTO	Zobr_WX_na_LCD	;

Zobr_WX_na_LCD				; Zobrazi pripraveny WX retezec
		; Teplota 1. radek
		MOVLW	b'10000000'	; nastavit kursor na 1. byte 1. radku
 		CALL	LCDPUTCMD
		MOVF	LCD_TempCz, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVF	LCD_TempCd, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVF	LCD_TempCj, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat  na LCD
		MOVLW	a'.'		; desetina tecka
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVF	LCD_TempCdes, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVLW	a'C'		; stupne Celsia
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVLW	a' '		; mezera
 		CALL	LCDPUTCHAR	; Poslat na LCD
		; Tlak
		MOVF	LCD_PresT, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVF	LCD_PresS, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVF	LCD_PresD, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat  na LCD
		MOVF	LCD_PresJ, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat  na LCD
		MOVLW	a'.'		; desetina tecka
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVF	LCD_PresDes, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVLW	a'h'		; 'hPa'
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVLW	a'P'		; 'hPa'
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVLW	a'a'		; 'hPa'
 		CALL	LCDPUTCHAR	; Poslat na LCD
		; Vlhkost - 2.radek
		MOVLW	b'11000000'	; nastavit kursor na 1. byte 2. radku
 		CALL	LCDPUTCMD
		MOVF	LCD_HumiD, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat  na LCD
		MOVF	LCD_HumiJ, W	; Vzit znak
 		CALL	LCDPUTCHAR	; Poslat  na LCD
		MOVLW	a'%'		; '%'
 		CALL	LCDPUTCHAR	; Poslat na LCD
		MOVLW	a' '		; mezera
 		CALL	LCDPUTCHAR	; Poslat na LCD
		; MIN a MAX teploty
		MOVF	LCD_TempCMINz, W	; Vzit znak
 		CALL	LCDPUTCHAR		; Poslat na LCD
		MOVF	LCD_TempCMINd, W	; Vzit znak
 		CALL	LCDPUTCHAR		; Poslat na LCD
		MOVF	LCD_TempCMINj, W	; Vzit znak
 		CALL	LCDPUTCHAR		; Poslat  na LCD
		MOVLW	a'.'			; desetina tecka
 		CALL	LCDPUTCHAR		; Poslat na LCD
		MOVF	LCD_TempCMINdes, W	; Vzit znak
 		CALL	LCDPUTCHAR		; Poslat na LCD
		MOVLW	a'C'			; stupne Celsia
 		CALL	LCDPUTCHAR		; Poslat na LCD
		MOVF	LCD_TempCMAXz, W	; Vzit znak
 		CALL	LCDPUTCHAR		; Poslat na LCD
		MOVF	LCD_TempCMAXd, W	; Vzit znak
 		CALL	LCDPUTCHAR		; Poslat na LCD
		MOVF	LCD_TempCMAXj, W	; Vzit znak
 		CALL	LCDPUTCHAR		; Poslat  na LCD
		MOVLW	a'.'			; desetina tecka
 		CALL	LCDPUTCHAR		; Poslat na LCD
		MOVF	LCD_TempCMAXdes, W	; Vzit znak
 		CALL	LCDPUTCHAR		; Poslat na LCD
		MOVLW	a'C'			; stupne Celsia
 		CALL	LCDPUTCHAR		; Poslat na LCD
		RETURN			; navrat
		
WX_RAMsend:				; posle obsah WX registru po RS232
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		MOVLW	WX_DATA_OFFSET	; zacatek WX retezce
		MOVWF	WX_temp		; dat sem

WX_dalsiRAMB:				; odesilaci smycka
		MOVF	WX_temp,W	; vzit adresu registru
		MOVWF	FSR		; dat ji sem a
		BSF	FSR,7
		MOVF	INDF,W		; nacist obsah REG na adrese FSR
		BCF	FSR,7
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		CALL	serial_SEND_byte	; odeslat po RS-232
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		INCF	WX_temp,F	; dalsi REG

		BTFSS	WX_temp,6	; nepretekli
		GOTO	WX_end_R_check	; jsme 
		BTFSS	WX_temp,5	; nepretekli
		GOTO	WX_end_R_check	; jsme 
		BTFSC	WX_temp,4	; v RAMce?
		GOTO	WX_end_R	; pretekli, konec 

WX_end_R_check:
		BSF	FSR,7
		MOVF	INDF,W		; nacist obsah REG na adrese FSR
		BCF	FSR,7
		XORWF	wx_data_endR, W	; ukoncovaci znak WX retezce
		BTFSS	STATUS,Z	; poslany vsechy WX registry?
		GOTO	WX_dalsiRAMB	; jeste ne
WX_end_R:
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		call	serialTXcr
		call	serialTXlf
		GOTO	Main_Loop	; poslano vse, zpet do hlavni smycky

Send_all_EEPROM:		; nacte data z EEPROM a posle na RS232
		MOVLW	EE_LEN		; delka dat v EEPROM
		CALL	serial_SEND_byte	; a poslat ji jako prvni
		CLRF	temp		; vynulovat ukazovatko

Send_all_EEPROM_Loop:		; smycka cteni z EEPROM
		MOVF	temp,W		; vzit adresu bytu v EEPROM
		CALL	EEPROM_Read_Byte	; nacist ho
		CALL	serial_SEND_byte	; a poslat po RS232
		INCF	temp,F		; posun na dalsi byte
		BTFSS	temp,EEPROM_size_bit	; bylo jich uz 128?
		GOTO	Send_all_EEPROM_Loop	; jeste ne, dalsi
		GOTO	Main_Loop	; vse odeslano, jedeme dokolecka

WX_RAM_Init:	
		MOVLW	WX_DATA_OFFSET	; zacatek WX retezce v RAM
		MOVWF	FSR		; dat ji sem a
		BSF	FSR,7		; Banka 1 ve FSR
		MOVLW	a'0'		; '000'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	002FH		; '/'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'0'		; '000'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'g'		; 'g'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'0'		; '000'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a't'		; 't'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'0'		; '000'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'b'		; 'b'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'0'		; '00000'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'h'		; 'h'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'0'		; '00'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	000DH		; 'CR'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a' '		; ' '
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'0'		; '000'
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVWF	INDF		; zapsat byte na adresu FSR
		INCF	FSR,F		; dalsi REG
		MOVLW	a'C'		; 'C'
		MOVWF	INDF		; zapsat byte na adresu FSR
		BCF	FSR,7		; Banka 0 ve FSR
		RETURN



		; Pojistky procesoru
		
		ORG	2007H

		DATA	0D02H

		; EEPROM procesoru

EEPROM_size_bit	EQU	007H		; Bitik preteceni EEPROM
EE_LEN		EQU	080H		; velikost EEPROM

		ORG	2100H

EE_DELAY_TIME	EQU	000H		; Adresa RS232 delay bytu v EEPROM
EE_WX_DATA_STRT	EQU	001H		; Adresa start. znaku WX retezce
EE_WX_DATA_END	EQU	002H		; Adresa ukonc. znaku WX retezce
EE_WX_ID_TF	EQU	003H		; Adresa ID teploty F
EE_WX_ID_TC	EQU	004H		; Adresa ID teploty C
EE_WX_ID_P	EQU	005H		; Adresa ID tlaku
EE_WX_ID_H	EQU	006H		; Adresa ID vlhkosti 

		DATA	001EH		; RS232 delay (1Eh@4MHz,52h@10MHz)
		DATA	a'!'		; Startovaci znak WX APRS retezce
		DATA	a'C'		; Ukoncovaci znak WX APRS retezce
		DATA	a't'		; ID teploty F
		DATA	000DH		; ID teploty C
		DATA	a'b'		; ID tlaku
		DATA	a'h'		; ID vlhkosti
		DATA	0000H		; 
		DATA	0000H		; 
		DATA	0000H		; 
		DATA	0000H		; 
		DATA	0000H		; 
		DATA	0000H		; 
		DATA	0000H		; 
		DATA	0000H		; 

		END
